#property copyright "http://dmffx.com"
#property link      "http://dmffx.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue

//---- input parameters



   /*
       "" .  ,    
         "" .     
       HLPeriod,      HLPeriod.   
              K, 
              MinStep 
      ,     ,  
         . 

      :
      
      HLPeriod -      ( ),   
      K -         .
      MinStep -    
      
       http://dmffx.com
   
   */


extern int     HLPeriod =  3;       //      ( ),   
extern double  K        =  0.5;     //         .
extern int     MinStep  =  10;      //    

//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   
   SetIndexLabel(0,"KvantLevel-2");   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
               double h=High[iHighest(NULL,0,MODE_HIGH,HLPeriod,i)];
               double l=Low[iLowest(NULL,0,MODE_LOW,HLPeriod,i)];
               double av=0;                  
                  for(int j=i;j<i+HLPeriod;j++){
                     av+=(High[j]-Low[j]);
                  }
               av/=HLPeriod;
                  if(av>=(h-l)*K){
                     double lev=(h+l)/2;
                        if(MathAbs(lev-ExtMapBuffer1[i])>=Point*MinStep){
                           ExtMapBuffer1[i]=lev;
                        }
                  }
            }

   return(0);
}
//+------------------------------------------------------------------+